#include "B4RDefines.h"
#if defined(ESP8266)
#include <ESP8266WiFi.h>
#else
#include <WiFi.h>
#endif
#include "raWOT.h"
//#include "MimeTypes.h"

 WiFiServer server(80); 
 
  // middleware, finally, notFound calls back
  void awot::middlewareCB(Request &req, Response &res, uint8_t Mindex) {
     B4R::B4RaWOT::middlewareCB(req, res, Mindex);
  };
  void awot::finallyCB(Request &req, Response &res) {
     B4R::B4RaWOT::finallyCB( req, res);
  };
  void awot::notFoundCB(Request &req, Response &res) {
     B4R::B4RaWOT::notFoundCB(req, res);
  };

namespace B4R
{
    B4RaWOT*  B4RaWOT::instance = NULL;
    Response* B4RaWOT::resSV = nullptr ;
    Request*  B4RaWOT::reqSV = nullptr ;   
    boolean   B4RaWOT::ptrON = false ; 
    IPAddress B4RaWOT::_IP;    
    void B4RaWOT::initialize(Subvoid_Byte MiddlewareCBSub, Subvoid_void FinallyCBSub, Subvoid_void NotFoundCBSub)
    { 
       server.begin();
//       MimeTypes mime; 
       rcs = new (backend) awot::Application; 
       this->MiddlewareCBSub = MiddlewareCBSub; 
       this->FinallyCBSub = FinallyCBSub; 
       this->NotFoundCBSub = NotFoundCBSub; 
       instance = this;
    };  
//****************************************************
//*************    B4RaWOT::Call Back; ***************
//****************************************************    
    void B4RaWOT::middlewareCB(Request &req, Response &res, uint8_t Mindex)
    { 
       B4RaWOT::ptrON = true; resSV = &res; reqSV = &req;
          instance->MiddlewareCBSub(Mindex); 
       B4RaWOT::ptrON = false;    
    };

    void B4RaWOT::finallyCB(Request &req, Response &res)
    {  
       B4RaWOT::ptrON = true; resSV = &res; reqSV = &req;
          instance->FinallyCBSub();
       B4RaWOT::ptrON = false;            
    };

    void B4RaWOT::notFoundCB(Request &req, Response &res)
    { 
         B4RaWOT::ptrON = true; resSV = &res; reqSV = &req;
          instance->NotFoundCBSub();
       B4RaWOT::ptrON = false;            
    }; 

//******************************************************
//*****    awot::Application awot::Application;    *****
//******************************************************   
    void B4RaWOT::process()
    {
       WiFiClient client = server.available();
       if (client.connected()) {
           _IP = client.remoteIP();
 //           app_SerialPrintln("RemoteIP:"+_IP.toString());
            rcs->process(&client);
            client.stop(); } 
     }
   
    B4RString* B4RaWOT::getClientIP()
    {
       return B4RString::PrintableToString(&_IP);
    } 
    
    ArrayByte* B4RaWOT::getClientIP1()
    {
       ArrayByte* ip = CreateStackMemoryObject(ArrayByte);
   	   ip->data = StackMemory::buffer + StackMemory::cp;
	   ip->length = 4;   
	   for (byte i = 0;i < 4;i++) {
	     ((Byte*)ip->data)[i] = _IP[i];
    	}
	   return ip;
    }     
     
    void B4RaWOT::app_del(B4RString* path,uint8_t Mindex)
    {  
       rcs->del(path->data, Mindex); 
    }

    void B4RaWOT::app_del1(uint8_t Mindex)
    { 
       rcs->del(Mindex);
    }
    
    void B4RaWOT::app_finally()
    { 
       rcs->finally(1);
    }

    void B4RaWOT::app_get(B4RString* path,uint8_t Mindex)
    {  
       rcs->get(path->data, Mindex);
    }

    void B4RaWOT::app_get1(uint8_t Mindex)
    {  
       rcs->get( Mindex);
    }

    void B4RaWOT::app_head(B4RString* path,uint8_t Mindex)
    {  
       rcs->head(path->data, Mindex);
    }

    void B4RaWOT::app_head1(uint8_t Mindex)
    {  
       rcs->head( Mindex);
    }

    void B4RaWOT::app_header(B4RString* name, ArrayByte* buffer)
    {  
       rcs->header(name->data, (char*)buffer->data, buffer->length);
    }

    void B4RaWOT::app_notFound()
    {  
       rcs->notFound(1);
    }

    void B4RaWOT::app_options(B4RString* path,uint8_t Mindex)
    {  
       rcs->options(path->data, Mindex);
    }

    void B4RaWOT::app_options1(uint8_t Mindex)
    {  
       rcs->options( Mindex);
    }

    void B4RaWOT::app_patch(B4RString* path,uint8_t Mindex)
    { 
       rcs->patch(path->data, Mindex);
    }

    void B4RaWOT::app_patch1(uint8_t Mindex)
    {  
       rcs->patch( Mindex);
    }

    void B4RaWOT::app_post(B4RString* path,uint8_t Mindex)
    { 
       rcs->post(path->data, Mindex);
    }

    void B4RaWOT::app_post1(uint8_t Mindex)
    {  
       rcs->post( Mindex);
    }

    void B4RaWOT::app_put(B4RString* path,uint8_t Mindex)
    {  
       rcs->put(path->data, Mindex);
    }

    void B4RaWOT::app_put1(uint8_t Mindex)
    {  
       rcs->put( Mindex);
    }

    void B4RaWOT::app_setTimeout(uint32_t timeoutMillis)
    {
       rcs->setTimeout(timeoutMillis);
    }

    void B4RaWOT::app_useR(B4RString* path,uint8_t Rindex) 
    {  
       rcs->useR(path->data, &m_router[Rindex]);
    }

    void B4RaWOT::app_useR1(uint8_t Rindex)
    { 
       rcs->useR( &m_router[Rindex]);
    }

    void B4RaWOT::app_use(B4RString* path,uint8_t Mindex)
    { 
       rcs->useM(path->data, Mindex);
    }

    void B4RaWOT::app_use1(uint8_t Mindex)
    { 
       rcs->useM( Mindex);
    }
    
    B4RString* B4RaWOT::Mime_getType(B4RString* filename)
    {  const char* raw = mime.MimeTypes::getType(filename->data);
       B4RString* arr = CreateStackMemoryObject(B4RString);
       arr->data = raw;
       return arr;       
    }
    
     void B4RaWOT::app_SerialPrintln(String txt)
    { 
       rcs->SerialPrintln(txt);
    }
    

//************************************************
//*****    awot::Response awot::response;    *****
//************************************************    
    int32_t B4RaWOT::res_availableForWrite()
    {  if (!ptrON) {return 0;}
       return resSV->availableForWrite();
    }

    int32_t B4RaWOT::res_bytesSent()
    {  if (!ptrON) {return 0;}
       return resSV->bytesSent();
    }

    void B4RaWOT::res_beginHeaders()
    {  if (!ptrON) {return;}
       resSV->beginHeaders();
    }

    void B4RaWOT::res_end()
    {  if (!ptrON) {return;}
       resSV->end();
    }

    void B4RaWOT::res_endHeaders()
    {  if (!ptrON) {return;}
       resSV->endHeaders();
    }

    bool B4RaWOT::res_ended()
    {  if (!ptrON) {return false;}
       return resSV->ended();
    }

    void B4RaWOT::res_flush()
    {  if (!ptrON) {return;}
       resSV->flush();
    }

    B4RString* B4RaWOT::res_get(B4RString* name)
    {  const char* raw = resSV->get(name->data);
       B4RString* arr = CreateStackMemoryObject(B4RString);
       arr->data = raw;
       return arr;       
    }

    bool B4RaWOT::res_headersSent()
    {  if (!ptrON) {return false;}
       return resSV->headersSent();
    }
    
//    void B4RaWOT::Response::printP(B4RString* Ustring)//    {//       response.printP(Ustring->data); //    }

    void B4RaWOT::res_print(B4RString* string)
    {  if (!ptrON) {return;}
       resSV->printa(string->data);
    }
    void B4RaWOT::res_println(B4RString* string)
    {  if (!ptrON) {return;}
       resSV->printlna(string->data);
    }
    void B4RaWOT::res_print1(ArrayByte* string)
    {  if (!ptrON) {return;}
       resSV->printb((char*)string->data, string->length);
    }
    void B4RaWOT::res_println1(ArrayByte* string)
    {  if (!ptrON) {return;}
       resSV->printlnb((char*)string->data, string->length);
    }  
    
    void B4RaWOT::res_sendStatus(int16_t code)
    {  if (!ptrON) {return;}
       resSV->sendStatus(code);
    }

    void B4RaWOT::res_set(B4RString* name, B4RString* value)
    {  if (!ptrON) {return;}
       resSV->set(name->data, value->data);
    }

    void B4RaWOT::res_setDefaults()
    {  if (!ptrON) {return;}
       resSV->setDefaults();
    }

    void B4RaWOT::res_status(int16_t code)
    {  if (!ptrON) {return;}
       resSV->status(code);
    }

    int16_t B4RaWOT::res_statusSent()
    {  if (!ptrON) {return 0;}
       return resSV->statusSent();
    }

    uint16_t B4RaWOT::res_write(uint8_t data)
    {  if (!ptrON) {return 0;}
       return resSV->write(data);
    }

    uint16_t B4RaWOT::res_write1(ArrayByte* buffer, uint16_t length)
    {  if (!ptrON) {return 0;}
       return resSV->write((byte*)buffer->data, length);
    }

//    void B4RaWOT::res_writeP(ArrayByte* data)
//    {
//       resSV->writeP((byte*)data->data, data->length);
//    }

//**********************************************
//*****    awot::Request awot::request;    *****
//**********************************************
    int32_t B4RaWOT::req_available()
    {  if (!ptrON) {return 0;}
       return reqSV->available();
    }

    int32_t B4RaWOT::req_availableForWrite()
    {  if (!ptrON) {return 0;}
       return reqSV->availableForWrite();
    }

    int32_t B4RaWOT::req_bytesRead()
    {  if (!ptrON) {return 0;}
       return reqSV->bytesRead();
    }

//    B4RStream* B4RaWOT::req_stream() //    { //       stream* str = reqSV->stream(); //       return  &str; //    }                     

    void B4RaWOT::req_flush()
    {  if (!ptrON) {return;}
       reqSV->flush();
    }

    bool B4RaWOT::req_form(ArrayByte* name,ArrayByte* value)
   {  if (!ptrON) {return false;}    
      char a; char* na = (char*)name->data; int na_l = name->length; char* va = (char*)value->data; int va_l = value->length;
       boolean ret = reqSV->form(na, na_l, va, va_l);
       for (int i=0; i< na_l; i++) {if (na[i] < 32) {na[i]=32;};};value->data=va;value->length=va_l;
       for (int i=0; i< va_l; i++) {if (va[i] < 32) {va[i]=32;} ;}value->data=va;value->length=va_l;
       return ret;
 //      return reqSV->form((char*)name->data, name->length, (char*)value->data, value->length); 
    }


    B4RString* B4RaWOT::req_get(B4RString* name)
    {  char* raw = reqSV->get(name->data);
       B4RString* arr = CreateStackMemoryObject(B4RString);
       arr->data = raw;
       return arr;
    }

    int32_t B4RaWOT::req_left()
    {  if (!ptrON) {return 0;}
       return reqSV->left();
    }

    Byte B4RaWOT::req_method()
    {  if (!ptrON) {return 0;}
//     enum MethodType {UNKNOWN, GET, HEAD, POST, PUT, DELETE, PATCH, OPTIONS, ALL}; 
       switch (reqSV->method()) {
       case Request::MethodType::UNKNOWN   : return 0;break;
       case Request::MethodType::GET       : return 1;break;
       case Request::MethodType::HEAD      : return 2;break;
       case Request::MethodType::POST      : return 3;break;
       case Request::MethodType::PUT       : return 4;break;
       case Request::MethodType::DELETE    : return 5;break; 
       case Request::MethodType::PATCH     : return 6;break; 
       case Request::MethodType::OPTIONS   : return 7;break;
       case Request::MethodType::ALL       : return 8;break;
       default                    : return 0;break;
       }   
    };
    
     B4RString* B4RaWOT::req_path()
    {  char* raw = reqSV->path();;
       B4RString* arr = CreateStackMemoryObject(B4RString);
       arr->data = raw;
       return arr;       
    }

    int32_t B4RaWOT::req_peek()
    {  if (!ptrON) {return 0;}
       return reqSV->peek();
    }

    void B4RaWOT::req_push(uint8_t ch)
    {  if (!ptrON) {return;}
       reqSV->push(ch);
    }

    B4RString* B4RaWOT::req_query()
    {  char* raw = reqSV->query();
       B4RString* arr = CreateStackMemoryObject(B4RString);
       arr->data = raw;
       return arr;              
    }

    bool B4RaWOT::req_query1(B4RString* name, ArrayByte* buffer)
    {  if (!ptrON) {return false;}
       return reqSV->query(name->data, (char*)buffer->data, buffer->length);
    }

    int32_t B4RaWOT::req_read()
    {  if (!ptrON) {return 0;}
       return reqSV->read();
    }

    int32_t B4RaWOT::req_read1(ArrayByte* buf)
    {  if (!ptrON) {return 0;}
       return reqSV->read((byte*)buf->data, buf->length);
    }

    bool B4RaWOT::req_route(B4RString* name, ArrayByte* buffer)
    {  if (!ptrON) {return false;}
       return reqSV->route(name->data,  (char*)buffer->data, buffer->length);
    }

    bool B4RaWOT::req_route1(int16_t number, ArrayByte* buffer)
    {  if (!ptrON) {return false;}
       return reqSV->route(number,  (char*)buffer->data, buffer->length);
    }

    int16_t B4RaWOT::req_minorVersion()
    {  if (!ptrON) {return 0;}
       return reqSV->minorVersion();
    }

    uint16_t B4RaWOT::req_write(uint8_t data)
    {  if (!ptrON) {return 0;}
       return reqSV->write(data);
    }

    uint16_t B4RaWOT::req_write1(ArrayByte* buffer, uint16_t length)
    {  if (!ptrON) {return 0;}
       return reqSV->write((byte*)buffer->data, length);
    }    

//**************************************
//*****    awot::Router router;    *****  
//**************************************  
    void B4RaWOT::rout_del(uint8_t RindexO, B4RString* path,uint8_t Mindex)
    { 
       m_router[RindexO].del(path->data, Mindex);
    }

    void B4RaWOT::rout_del1(uint8_t RindexO, uint8_t Mindex)
    { 
       m_router[RindexO].del( Mindex);
    }

    void B4RaWOT::rout_get(uint8_t RindexO, B4RString* path,uint8_t Mindex)
    { 
       m_router[RindexO].get(path->data, Mindex);
    }

    void B4RaWOT::rout_get1(uint8_t RindexO, uint8_t Mindex)
    { 
       m_router[RindexO].get( Mindex);
    }

    void B4RaWOT::rout_head(uint8_t RindexO, B4RString* path,uint8_t Mindex)
    { 
       m_router[RindexO].head(path->data, Mindex);
    }

    void B4RaWOT::rout_head1(uint8_t RindexO, uint8_t Mindex)
    { 
       m_router[RindexO].head( Mindex);
    }

    void B4RaWOT::rout_options(uint8_t RindexO, B4RString* path,uint8_t Mindex)
    { 
       m_router[RindexO].options(path->data, Mindex);
    }

    void B4RaWOT::rout_options1(uint8_t RindexO, uint8_t Mindex)
    { 
       m_router[RindexO].options( Mindex);
    }

    void B4RaWOT::rout_patch(uint8_t RindexO, B4RString* path,uint8_t Mindex)
    { 
       m_router[RindexO].patch(path->data, Mindex);
    }

    void B4RaWOT::rout_patch1(uint8_t RindexO, uint8_t Mindex)
    { 
       m_router[RindexO].patch( Mindex);
    }

    void B4RaWOT::rout_post(uint8_t RindexO, B4RString* path,uint8_t Mindex)
    { 
       m_router[RindexO].post(path->data, Mindex);
    }

    void B4RaWOT::rout_post1(uint8_t RindexO, uint8_t Mindex)
    { 
       m_router[RindexO].post( Mindex);
    }

    void B4RaWOT::rout_put(uint8_t RindexO, B4RString* path,uint8_t Mindex)
    { 
       m_router[RindexO].put(path->data, Mindex);
    }

    void B4RaWOT::rout_put1(uint8_t RindexO, uint8_t Mindex)
    { 
       m_router[RindexO].put( Mindex);
    }

    void B4RaWOT::rout_useR(uint8_t RindexO, B4RString* path,uint8_t Rindex)
    {  
       m_router[RindexO].useR(path->data, &m_router[Rindex]);
    }

    void B4RaWOT::rout_useR1(uint8_t RindexO, uint8_t Rindex)
    {  
       m_router[RindexO].useR( &m_router[Rindex]);
    }

    void B4RaWOT::rout_use(uint8_t RindexO, B4RString* path,uint8_t Mindex)
    {  
       m_router[RindexO].useM(path->data, Mindex);
    }

    void B4RaWOT::rout_use1(uint8_t RindexO, uint8_t Mindex)
    {  
       m_router[RindexO].useM( Mindex);
    }
    
}
